--[[
Brian T.Wilcox
twingears@gmail.com
"MATH Fun" program(s) remake 2023
]]
math.randomseed(os.time())
local utf8 = require("utf8")

function love.load(arg)
    --help getting the debugger to kick in for ZeroBrane
    if arg[#arg] == "-debug" then 
        require("mobdebug").start()
    end

--    game = Game()                               --game state
--local mouseX, mouseY = love.mouse.getPosition()
    Classic = require 'lib/classic'
    newButton = Classic.extend(Classic) --PascalCase for Class
    require 'source/Button'
    require 'source/constants'
    require 'source/Menu'
    require 'source/Math'
    
    love.window.setTitle("Jump Over Any Nova Sun - Math Fun" .. " - " .. reVision) --didn't like being in constants.lua file...
    
    love.keyboard.setKeyRepeat( false )     --THIS WORKS ON KEYBOARD VERY WELL - WHAT ABOUT THE MOUSE?
    love.keyboard.hasKeyRepeat( false )
    
end
--utf8 ONLY WORKS PROPERLY WHEN USING Love.keypressed()...
--[[keyboard actions that are allowed during run time of math program
    -, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, <return or enter>, <backspace>
    If a key(s) have been pressed && dt say .5 seconds have passed
    menuREADY = false
    thus the answer can be updated into menu to be re-drawn
    ]]

--2024 stripping down to only the MATH program on display
function love.update(dt)
    if eqREADY == false then
        eqREADY, tableEQ, correctAnswer, eqString = uEQtable(col, row) --eqREADY returned true
        if menuREADY then
            menuREADY = false
        end
    elseif menuREADY == false and eqREADY then
        menuREADY = uMenuMathTable()    --
    end
--    timer = timer + dt
--    if timer > timerDefault then
--        timer = timer - timerDefault
----        love.timer.sleep(timer)
--        print(timer)
--    end
end

function love:draw()
    if menuREADY then --draw menu
--        love.graphics.clear(0,0,0,1)
        dMenuMath()
    end
--    if menu then --and #tMenu > 1 then
--        dMainMenu()
--    elseif menu == false and mathSIGN ~= "NONE" then --mSwitch == "Addition" or "Subtraction" then
--    end
    --love.graphics.rectangle("line", 0, 5, 64, 64)
--    love.graphics.printf(gEquation, 10, 0, 400, 'right') --printf right/center algnement with 500px wall wordwrap width
end

--seems to need to be under the .update && .draw looping
--only working on keyboard as of yet...
function love.keypressed(key)
    if key == "escape" then
        love.event.quit()
    elseif key == "backspace" then
        if #tostring(answerBox) > 0 then --and (mathSIGN == "+" or "-") then --and byteoffset then
            local byteoffset = utf8.offset(answerBox, -1)
            answerBox = string.sub(answerBox, 1, byteoffset -1)
--          print("ECHO from the keyboard main update " .. answerBox)
        end
    elseif key == "0" then
        answerBox = answerBox .. "0"
    elseif key == "1" then
        answerBox = answerBox .. "1"
    elseif key == "2" then
        answerBox = answerBox .. "2"
    elseif key == "3" then
        answerBox = answerBox .. "3"
    elseif key == "4" then
        answerBox = answerBox .. "4"
    elseif key == "5" then
        answerBox = answerBox .. "5"
    elseif key == "6" then
        answerBox = answerBox .. "6"
    elseif key == "7" then
        answerBox = answerBox .. "7"
    elseif key == "8" then
        answerBox = answerBox .. "8"
    elseif key == "9" then
        answerBox = answerBox .. "9"
    elseif key == "." then
        answerBox = answerBox .. "."
    elseif key == "-" then
        answerBox = "-" .. answerBox
    elseif key == "return" then
        answerCheck()
    end
    menuREADY = false
end

--This mirrors the 1st set of keys and we need dt in the mix to stop the repeats
function love.touchpressed(key)
    dt = 0
    if key == "escape" then
        love.event.quit()
    elseif key == "backspace" then
        if #tostring(answerBox) > 0 then --and (mathSIGN == "+" or "-") then --and byteoffset then
            local byteoffset = utf8.offset(answerBox, -1)
            answerBox = string.sub(answerBox, 1, byteoffset -1)
--          print("ECHO from the keyboard main update " .. answerBox)
        end
    elseif key == "0" then
        answerBox = answerBox .. "0"
    elseif key == "1" then
        answerBox = answerBox .. "1"
    elseif key == "2" then
        answerBox = answerBox .. "2"
    elseif key == "3" then
        answerBox = answerBox .. "3"
    elseif key == "4" then
        answerBox = answerBox .. "4"
    elseif key == "5" then
        answerBox = answerBox .. "5"
    elseif key == "6" then
        answerBox = answerBox .. "6"
    elseif key == "7" then
        answerBox = answerBox .. "7"
    elseif key == "8" then
        answerBox = answerBox .. "8"
    elseif key == "9" then
        answerBox = answerBox .. "9"
    elseif key == "." then
        answerBox = answerBox .. "."
    elseif key == "-" then
        answerBox = "-" .. answerBox
    end
    menuREADY = false
end